// KEKS/CM -- KEKS-encoded cryptographic messages
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package gost

import (
	"crypto/rand"
	"errors"

	"go.cypherpunks.su/gogost/v6/gost3410"
)

func NewKeypair(algo string) (prv, pub []byte, err error) {
	curve := CurveByName(algo)
	if curve == nil {
		err = errors.New("unknown curve")
		return
	}
	prv = make([]byte, curve.PointSize())
	rand.Read(prv)
	var pk *gost3410.PrivateKey
	pk, err = gost3410.NewPrivateKeyBE(curve, prv)
	if err != nil {
		return
	}
	_, pub, err = NewSigner(pk.RawBE())
	return
}
